program MCPE;
{OCR'd, scrubbed, translated and compiled by WaveWatcher of
http://www.overunityresearch.com for the purpose of aiding understanding
of Prof. Dr. Tutur's ideas by fellow OUR members.}
{WW}
{The orginal program source code - and any copyrights belong to the author:
Professor Dr. Claus W. Turtur of
Fachbereich Elektrotechnik
University of Applied Sciences
Braunschweig-Wolfenbuettel
{WW}
{The article displaying the original source code is located at:
http://philica.com/display_article.php?article_id=219}
{WW}


//prog name shortened to MCPE     WW
//program Magnetic_converter_with_power_extraction;     WW

{$APPTYPE CONSOLE}

{ original uses block not needed - useless file size increase!   WW
uses
  Windows,
  Messages,
  SysUtils,
  Classes,
  Graphics,
  Controls,
  Forms,
  Dialogs;
}

uses Windows;             //WW

Const AnzPmax=10000; {number of time-steps to solve the differential equation}

Type Feld = Array[0..AnzPmax] of Double;    // feld means field   WW

Var
  epo, muo    : Double;{constants of nature}
  lichtgesch  : Double;{speed of light}
  n           : LongInt; {number of windings in the coil}
  A           : Double;{cross section area of the coil}
  Bo	:	Double;
  ls	:	Double;
  di	:	Double;
  Dd	:	Double;
  rm	:	Double;
  L	:	Double;
  C	:	Double;
  R	:	Double;
  rho	:	Double;
  phi, phip, phipp	:	Feld;
  Q, Qp, Qpp	:	Feld;
  i	:	LongInt;
  AnzP	:	Longint;
  dt	:	Double;
  Abstd	:	Integer;
  omo	:	Double;
  T	:	Double;
  VC, VL	:	Double;
  rhom	:	Double;
  dm	:	Double;
  mt	:	Double;
  J	:	Double;
  K0, K1, K2, K3, K4, K5	:	Feld;
  Ema, EmE, siA, siE	:	Double;
  delE, sigdelE	:	Double;
  VmAn	:	Double;
  Eent	:	Double;
  Rlast	:	Double;

Procedure Wait;
Var Ki	:	Char;
Begin
		Write('<W>');
		Read(Ki);
		Write(ki);
		If Ki='e' then Halt;    // I hope you know what Halt means :-P. WW
end;

// Excel Ausgabe = Excel Output    WW
Procedure ExcelAusgabe(Name:  String; Spalten: Integer; KA,KB,KC,KD,KE,KF,KG,KH,KI,KJ,KK,Kl: Feld);
Var
fout: Text; {Up to 12 column can be written}
lv, j, k: Integer; {counter}
Zahl: String; {to be printed to Excel}
begin
    Assign(fout,Name); Rewrite(fout); {open File}
    For lv:=0 to AnzP do {from plotf to plotend}
      begin
          if (lv mod Abstd)=0 then
            begin
                for j:= 1 to Spalten do
                  begin {Kolumnen drucken} // Print Columns  WW
                      If j=1 then Str(KA[lv]:19:14,Zahl);
                      If j=2 then Str(KB[lv]:19:14,Zahl);
                      If j=3 then Str(KC[lv]:19:14,Zahl);
                      If j=4 then Str(KD[lv]:19:14,Zahl);
                      If j=5 then Str(KE[lv]:19:14,Zahl);
                      If j=6 then Str(KF[lv]:19:14,Zahl);
                      If j=7 then Str(KG[lv]:19:14,Zahl);
                      If j=8 then Str(KH[lv]:19:14,Zahl);
                      If j=9 then Str(KI[lv]:19:14,Zahl);
                      If j=10 then Str(KJ[lv]:19:14,Zahl);
                      If j=11 then Str(KK[lv]:19:14,Zahl);
                      If j=12 then Str(KL[lv]:19:14,Zahl);

                      For k:=1 to Length(Zahl) do
                        begin {use commata, not decimal points}
            {conversion of decimal point to comma blocked for English   WW}
                  //        If Zahl [k] <> ',' then write(fout,Zahl[k]);  WW
                  //        If Zahl [k] = '.' then write(fout,',');     WW
                            Write(fout, Zahl[k]); //WW
                        end;

                      Write(fout,chr(09)); {Data separation, Tabulator}
                  end;
                WriteLn(fout,{''} chr(10)+chr(13)); {line-feed} {Changed to line-feed & carriage return   WW}
            end;
          end;
          Close(fout);
end;

procedure ScrHeader;  // added by Wav3Watch3r
var
sbi : TConsoleScreenBufferInfo;
i : integer;

begin
    WriteLn('OCR`d, scrubbed, translated (to English and decimal point instead of comma)and');
    WriteLn('compiled by WaveWatcher of http://www.overunityresearch.com for the purpose of');
    WriteLn('aiding fellow OUR members in understanding the work of Prof. Dr. Turtur');
    WriteLn('   ');
    WriteLn('The orginal program source code - and any copyrights belong to the author:');
    WriteLn('Professor Dr. Claus W. Turtur');
    WriteLn('of:             ');
    WriteLn('Fachbereich Elektrotechnik ');
    WriteLn('University of Applied Sciences ');
    WriteLn('Braunschweig-Wolfenbuettel  ');
    WriteLn('                     ');
    WriteLn('The article displaying the original source code is located at: ');
    WriteLn('http://philica.com/display_article.php?article_id=219');
    WriteLn('                               ');
    WriteLn('Press Enter to continue to the program.....');
    GetConsoleScreenBufferInfo(GetStdHandle(STD_OUTPUT_HANDLE),sbi);
    Readln;
    GetConsoleScreenBufferInfo(GetStdHandle(STD_OUTPUT_HANDLE),sbi);
    for i := 0 to sbi.dwSize.y do writeln;
end;


begin {main program}
    ScrHeader;    //WW
    WriteLn('vacuum-energy-converter with rotation. ');
    { Input Parameters:}
    epo := 8.854187817E-12{As/Vm}; {Magnetic constant}
    muo := 4*pi*1E-7 {Vs/Am}; {Elektric constant}
    lichtgesch := Sqrt(1/muo/epo){m/s};
    WriteLn('speed of light c = ',lichtgesch, ' m/s');
    { coil, magnet, capacitor:}
    n :=1600; {number of windings in the coil}
    di := 0.09; {diameter of the coil body}
    Dd := 0.0010; {diameter of the wire}
    Bo := 0.700; {Tesla} {Magnetic field (Amplitude) of the permanent magnet}
    ls := 0.01; {Meter) {length of the cylindrical coil}
    C := 0.23E-6; {Farad} {capacity of the capacitor}
    rm := 0.039; {Meter} {Radius of the cylindrical permanent magnet}
    dm := 0.01; {Meter} {thickness of the cylindrical permanent magnet}
    rhom := 7.8E3; {density of the magnet-material, iron}
   { composed Parameters, calculated from the above Parameters: }
    A := di*di; {Meter * Meter} {cross section area of the coil}
    L := muo*a*n*n/ls; {Inductivity of the coil}
    omo := 1/Sqrt(L*C); {characteristic frequency of the electric oscillation-circuit}
    T :=2*pi/omo; {duration per oscillion of the electric oscillation-circuit}
    rho := 1.7E-8; {Ohm * m) {Specific resistance of the copper wire}
    R := rho*(2*pi*di*n)/(pi*(Dd/2)*(Dd/2)); {Glue} {Ohms resistance of the coils wire}
    { Sonstige:}
    VmAn := 100; {Start value: revolutions per second at the beginning}
    Rlast := 28; {Ohms resistance for load}
    AnzP := AnzPmax; {number of the time-steps in computation}
    dt := 0.0001; {sec.} {duration of the time-steps in computation}
    Abstd:=1; {how many points to be plotted}
    mt := pi*rm*rm*dm*rhom; {mass of the cylindrical magnet}
    J := 1/2*mt*rm*rm; {moment of inertia of the cylindrical magnet]
   { Anzeige der werte:}
    Writeln('Inductivity of the coil: L = ',L,' Henry');
    Writeln('Freqency of the harmon.el.Osc.: omo = ',omo:8:4,' Hz => T = ',T:15, 'sec. ');
    Writeln('length of the coil-wire: ',(2*pi*di*n),' m');
    Writeln('Ohmic resistance of the coil-wire: R = ',R:8:2, ' Ohm');
    Writeln('Mass of the cylindrical permanent magnet: mt = ',mt,' kg');
    Writeln('moment of inertia of the cylindrical magnet: J = ',J,' kg*m^2');
    Writeln('total duration of operation: ',AnzP*dt,' sec.');
    {Begin of the comptation.}
    Writeln( 'Mechanical and electrical linked oscillation.');
    VC := 0;{Volt} Q[0] := C*VC; Qpp[0] := 0; Qp[0] := 0; {Electrical initial values}
    phi[0] := 0; phip[0] := VmAn*2*pi; phipp[0] := 0; {Mechanical initial values}
    Eent := 0; {Reset for: extracted Energy, electrically}
    K0[0] := 0;
    K1[0] := 1/2*L*Sqrt(Qp[0]); {coil-Energy}
    K2[0] := 1/2*C*Sqr(Q[0]/C); {capacitor- Energy}
    K3[0] := 1/2*J*Sqr(phip[0]); {Rotation-Energy}
    K4[0] := K1[0]+K2[0]+K3[0]; {totalEnergy}
    K5[0] := 0;
    For i:= 1 to AnzP do
      begin
        Qpp[i] := -1/L/C*Q[i-1]-(R+Rlast)/2/L*Qp[i-1];
        Qpp[i] := Qpp[i]+n*Bo*A*sin(phi[i-1])*phip[i-1]/L; {Induced voltage into the coil.}
        Qp[i] := Qp[i-1]+(Qpp[i]-R/2/L*Qp[i-1])*dt;
        Q[i] := Q[i-1]+Qp[i]*dt;
        phipp[i] :=-Bo*n*Qp[i]*A/J*sin(phi[i-1]); {Mechanical torque, x-component}
        phip[i] := phip[i-1]+phipp[i]*dt;
        phi[i] := phi[i-1]+phip[i]*dt;
        K0[i] := 0;
        K1[i] := 1/2*L*Sqr(Qp[i]); {coil-Energy}
        K2[i] := 1/2*C*Sqr(Q[i]/C); {Kondensator-Energie}    // capacitor energy (in two ways?) WW
        K3[i] := 1/2*J*Sqr(phip[i]); {capacitor-Energy}
        K4[i] := K1[i]+K2[i]+K3[i]; {total-nergy}
        K5[i] := Rlast*Sqr(Qp[i]); {extracted power at the load resistor}
        Eent := Eent+K5[i]*dt; {extracted energy at the load resistor}
      end;
     {total-Energy-balance and display of the results:}
     EmA := 0; EmE := 0; siA := 0; siE := 0;
     For i := 1 to 10 do EmA := EmA+K4[i]/10; {average a the beginning}
     For i := AnzP-9 to AnzP do EmE := EmE+K4[i]/10; {average at the End}
     For i := 1 to 10 do siA := siA+Sqr(EmA-K4[i]); {Variance at the beginning}
     For i := AnzP-9 to AnzP do siE := siE+Sqr(EmE-K4[i]); {Variance at the End}
     siA := Sqrt(siA)/10; siE := Sqrt(siE)/10; {root mean square deviation}
     Writeln('Energy-values: E_begin = (',EmA:11:7,' +/- ',siA:11:7,') Joules');
     Writeln('               E_End   = (',EmE:11:7,' +/- ',siE:11:7,') Joules');
     delE := EmE-EmA; sigdelE := Sqrt(Sqr(siE)+Sqr(siA));
     Writeln('=> alteration: delta_E = (',delE:11:7,' +/- ',sigdelE:11:7,') Joule');
     Writeln('conv. power = ( ',delE/(AnzP*dt):11:7,' +/- ',sigdelE/(AnzP*dt):11:7, ') W');
     Writeln('extracted power at the load resistor = ',Eent/(AnzP*dt):11:7,' Watts');
     ExcelAusgabe('test_04.dat',12,Q,Qp,Qpp,phi,phip,phipp,K0,K1,K2,K3,K4,K5);
     //Wait; Wait;    //WW
     Writeln('         ');      //WW
     Writeln('Press Enter To Close This Window....');   //WW
     Readln;   //WW
End.
